#= require validation

$ ->  # shorthand for `$(document).ready ->`
  $signupBox = $ '#signup_box'
  
  # vertically center the signup box
  do centerSignupBox = ->
    $signupBox.css 'top', ($(window).height() - $signupBox.height()) / 2 + 'px'
  $(window).resize centerSignupBox
  
  # display helpful tip next to current input
  $tip = null
  $('input[type!="submit"]').focus( ->
    $fieldset = $(this).parent()
    $fieldset.children().remove('.tip')
    $tip = $ '<div class="tip"></div>'
    html = switch $fieldset.attr('id')
      when 'username_fieldset'
        'Pick a unique name with 3 to 16 characters.'
      when 'email_fieldset'
        'We won’t share your email address with anyone.'
      when 'password_fieldset'
        'Please enter a strong password to keep your account secure.'
      when 'confirm_password_fieldset'
        'Now retype the same password to make sure we got it right.'
    $fieldset.append $tip.html(html).fadeIn(500)
  ).blur( ->
    $tip?.fadeOut(500, -> $(this).remove())
    $fieldset = $(this).parent()
    errStr = switch $fieldset.attr('id')
      when 'username_fieldset'
        validate.username $(this).val()
      when 'email_fieldset'
        validate.email $(this).val()
      when 'password_fieldset'
        validate.password $(this).val()
      when 'confirm_password_fieldset'
        validate.confirmPassword $(this).val(), $('#password_input').val()
    if errStr
      $err = $ '<div class="tip error"></div>'
      $fieldset.children().remove('.tip')
      $fieldset.append $err.html(errStr).fadeIn(500)
  )
  
  # bring the cursor to the first input box
  $('input:first').focus()