# validate methods return an error string, or `null` if there are no errors
@validate = validate =
  username: (str) ->
    if str.length < 3
      'That username is too short.'
    else if str.length > 16
      'That username is too long.'
    else
      null
  
  email: (str) ->
    if !str.match /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/
      'Please enter a valid email address.'
    else
      null
  
  password: (str) ->
    score = str.length / 2
    if str.match /\d/ then score++
    if str.match /[a-z]/ then score++
    if str.match /[A-Z]/ then score++
    if str.match /[^a-zA-Z0-9]/ then score *= 2
    if score < 10
      'Please use a stronger password.'
    else
      null
  
  confirmPassword: (password, str) ->
    return null unless validate.password password
    if password isnt str
      'This does not match your password; try again.'
    else
      null
  
  all: (params) ->
    for field of validate when field isnt 'all'
      err = validate[field] params[field]
      return err if err
    null